;	 smtp_demo.pb
;	 Version 0.1 [2010/08/23]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

; Ldt eine Mail und versendet sie
; die Mail kann mit htmlmail_demo, mailalt_demo, mailatt_demo, plainmail_demo
; erzeugt werden

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awsmtp.pbi"
XIncludeFile "awmessage.pbi"

Define *smtp.AWPB_SMTPClient, *msg.AWPB_Message, file.s, err.i

InitNetwork()     ;- fr smtp ntig
OpenConsole()

PrintN("AWPB-Tools SMTP-Demo")
PrintN("")

Print("Allocating Message ... ")
*msg = AWPB_CreateMessageObj()
If *msg
  PrintN("success")
  file = OpenFileRequester("Please choose file to load", "", "EML-Files (*.eml)|*.eml", 0)
  If file
    Print("Loading mail ... ")
    If *msg\LoadEML(file)  
      PrintN("done")
      Print("Allocating SMTP-Client ... ")
      *smtp = AWPB_CreateSMTPClientObj()
      If *smtp
        PrintN("success")
        *smtp\SetServer("mail.gmx.net", 25)    ;- Set  Mailserver und Port eintragen
        *smtp\SetLogin("LOGIN", "PASS")        ;- Set  Login und Passwort eintragen        
        Print("Connecting ... ")
        err = *smtp\Connect()
        If err = #AWPB_SMTP_ERR_NONE
          PrintN("done")
          Print("Sending message ... ")
          err = *smtp\SendMail(*msg)
          If err = #AWPB_SMTP_ERR_NONE
            PrintN("success")
          Else
            Select err
              Case #AWPB_SMTP_ERR_FAIL:   PrintN("failed - general failure")
              Default:                    PrintN("failed - unknown error")
            EndSelect
            PrintN("Server replied: " + *smtp\GetServerResult())
          EndIf
          Print("Disconnecting ... ")
          If *smtp\DisConnect() = #AWPB_SMTP_ERR_NONE
            PrintN("done")
          Else
            PrintN("failed")
          EndIf          
        Else
          Select err
            Case #AWPB_SMTP_ERR_FAIL:   PrintN("failed - general failure")
            Case #AWPB_SMTP_ERR_LOGIN:  PrintN("failed - login failed")
            Case #AWPB_SMTP_ERR_USER:   PrintN("failed - username incorrect")
            Case #AWPB_SMTP_ERR_PASS:   PrintN("failed - password incorrect")
            Default:                    PrintN("failed - unknown error")
          EndSelect
          PrintN("Server replied: " + *smtp\GetServerResult())
        EndIf
        *smtp\Destroy()
      Else
        PrintN("failed")
      EndIf
    Else
      PrintN("failed")
    EndIf
  EndIf
  *msg\Destroy()
Else
  PrintN("failed")
EndIf

PrintN("Press return to exit")
Input()
