;	 webview_demo.pb
;	 Version 0.1 [2011/01/21]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awwebview.pbi"


; Callback Procedures
Procedure TitleChangedCB(title.s)
  PrintN("New Page Title: " + title)
;  Debug "New Page Title: " + title
EndProcedure
Procedure LinkOverCB(title.s, link.s)
  PrintN("Mouse over Link: " + link + " * Title: " + title)
;  Debug "Mouse over Link: " + link
EndProcedure
Procedure.i NavigationRequestedCB(link.s)
  PrintN("Navigate: " + link)
;  Debug "Navigate: " + link
  ProcedureReturn #AWPB_WEBKIT_NAVIGATION_IGNORE
EndProcedure
Procedure StatusBarTextCB(text.s)
  PrintN("Status Text: " + text)
;  Debug "Status Text: " + text
EndProcedure
Procedure PopulatePopupCB(*Menu.GtkMenu)
  PrintN("Popup called")
;  Debug "Popup called"
EndProcedure
Procedure ProgressChangedCB(progress.l)
  PrintN("Progress: " + Str(progress))
;  Debug "Progress: " + Str(progress)
EndProcedure

   
    
Define *webview.AWPB_WebView, event

OpenConsole()

If AWPB_InitWebKit("/usr/lib/libwebkit-1.0.so.2")
  OpenWindow(0, 0, 0, 800, 400, "WebKit Demo")
  
  *webview = AWPB_WebView(1, 5, 5, 790, 390, #PB_Container_Raised)
  If *webview
    *webview\OnHoveringOverLink(@LinkOverCB())
    *webview\OnLoadProgressChanged(@ProgressChangedCB())
    *webview\OnNavigationRequested(@NavigationRequestedCB())
    *webview\OnPopulatePopup(@PopulatePopupCB())
    *webview\OnStatusBarTextChanged(@StatusBarTextCB())
    *webview\OnTitleChanged(@TitleChangedCB())
    
    *webview\LoadURI("http://www.purebasic.com")
  
    Repeat
      event = WaitWindowEvent()
    Until event = #PB_Event_CloseWindow
  EndIf
Else
  MessageRequester("Fehler", "Kann WebKit-Library nicht initialisieren!")
EndIf

