;    awlocale.pbi
;    Version 0.1 [2010/09/28]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

;**
;* awlocale.pbi_
;* Version 0.1_
;* _
;* Multilanguage-Support fr PureBasic 4.50+_
;* Lizenz: LGPL V3_
;* _
;* Systemanforderungen:_
;* <table style="text-align: left;" border="0" cellpadding="2" cellspacing="0"><tbody><tr>
;* <td style="vertical-align: top;">Windows</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Linux</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Mac</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">x86</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">x64</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">PPC</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">ASCII</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Unicode</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;"></td><td style="vertical-align: top;"></td></tr></tbody></table>

;{ private functions
;{ Variables
NewMap ____LNG_Catalog.s()
;}
;{ functions
Procedure.s ____LNG_DeEscapeString(str.s)
  Protected esc.i, *str, a.i, target.s, *dst, len.i, c.c, b.i, m.i, d.i
  
  len    = Len(str)
  target = Space(len)
  *str   = @str
  *dst   = @target
  esc    = 0
  For a = 1 To len
    c = PeekC(*str) : *str + SizeOf(character)
    If c = '\'
      esc + 1
    Else
      If esc
        m = esc % 2
        d = Int(esc / 2)
        For b = 1 To d : PokeC(*dst, '\') : *dst + SizeOf(character) : Next b
        If m  ; ungrade anzahl an "\" -> esc-sequenz
          Select c
            Case 't': PokeC(*dst, $09)
            Case 'n': PokeC(*dst, $0a)
            Case 'r': PokeC(*dst, $0d)
            Default : PokeC(*dst, ' ')
          EndSelect
          *dst + SizeOf(character)
        Else  ; grade anzahl an "\" -> keine esc-sequenz; c bernehmen
          PokeC(*dst, c) : *dst + SizeOf(character)
        EndIf
        esc = 0
      Else ; keine esc-sequenz, c bernehmen
        PokeC(*dst, c) : *dst + SizeOf(character)
      EndIf
    EndIf
  Next a
  If len : PokeC(*dst, $00) : EndIf
  
  ProcedureReturn target
EndProcedure
Procedure   ____LNG_ClearCatalog()
  Shared ____LNG_Catalog()  
  
  ClearMap(____LNG_Catalog())
EndProcedure
Procedure.b ____LNG_AppendCatalog(filename.s, format.i)
  Shared ____LNG_Catalog()  
  Protected file.i, key.s, value.s, p.i
  
  file = ReadFile(#PB_Any, filename)
  If IsFile(file)
    While Not Eof(file)
      key   = ReadString(file, format)
      If Left(key, 1) <> "#"                    ; mit # werden kommentare eingeleitet
        p = FindString(key, "=", 2)
        If p                                    ; = in der Zeile, mindestens 2. Stelle
          value = Trim(Mid(key, p + 1))
          key   = LCase(Trim(Left(key, p - 1)))
          ____LNG_Catalog(key) = ____LNG_DeEscapeString(value)
        EndIf
      EndIf
    Wend
    CloseFile(file)
  Else
    ProcedureReturn #False
  EndIf
  
  ProcedureReturn #True
EndProcedure  
Procedure.b ____LNG_LoadCatalog(filename.s, format.i)
  ____LNG_ClearCatalog()
  ProcedureReturn ____LNG_AppendCatalog(filename, format)
EndProcedure
Procedure   ____LNG_ReplaceText(key.s, val.s)
  Shared ____LNG_Catalog()
  
  ____LNG_Catalog(LCase(key)) = val
EndProcedure
Procedure.s ____LNG_Text(key.s, defval.s)
  Shared ____LNG_Catalog()
  Protected res.s
  
  If FindMapElement(____LNG_Catalog(), LCase(key))
    res = ____LNG_Catalog()
  Else
    res = defval
  EndIf
  
  ProcedureReturn res
EndProcedure
;}
;}
;{ public functions
;** awpb_lng_loadcatalog
;* Ldt eine Sprachdatei._
;* Abhngig vom Format der Datei muss der format-Parameter gesetzt sein, da das laden sonst fehlschlgt oder merkwrdige Ergebnisse liefert._
;* Rckgabe ist bei Erfolg #True sonst #False.
;** .filename.s: Dateiname der Sprachdatei
;** .format.i: Format der Datei. folgende Werte sind mglich:
;* <ul><li>#PB_Ascii - Ascii-Datei</li><li>#PB_Utf8 - UTF8-Datei</li><li>#PB_UniCode - UniCode-Datei</li></ul>
;* Wird kein Format angegeben, wird eine ASCII-Datei erwartet.
Procedure.b AWPB_LNG_LoadCatalog(filename.s, format.i = #PB_Ascii)
  ProcedureReturn ____LNG_LoadCatalog(filename, format)
EndProcedure
;** awpb_lng_appendcatalog
;* Ldt eine Sprachdatei und hngt sie an die aktuellen Daten an._
;* Abhngig vom Format der Datei muss der format-Parameter gesetzt sein, da das laden sonst fehlschlgt oder merkwrdige Ergebnisse liefert._
;* Sollten doppelte Eintrge vorhanden sein, wird das letzte Vorkommen genutzt.
;* Rckgabe ist bei Erfolg #True sonst #False.
;** .filename.s: Dateiname der Sprachdatei
;** .format.i: Format der Datei. folgende Werte sind mglich:
;* <ul><li>#PB_Ascii - Ascii-Datei</li><li>#PB_Utf8 - UTF8-Datei</li><li>#PB_UniCode - UniCode-Datei</li></ul>
;* Wird kein Format angegeben, wird eine ASCII-Datei erwartet.
Procedure.b AWPB_LNG_AppendCatalog(filename.s, format.i = #PB_Ascii)
  ProcedureReturn ____LNG_AppendCatalog(filename, format)
EndProcedure
;** awpb_lng_text
;* Gibt einen Katalogeintrag zurck. Existiert dieser nicht (z.b. keine Datei geladen), wird deftext zurckgegeben.
;** .key.s: Schlssel des Spracheintrags
;** .deftext.s: Vorgabe, wenn kein Eintrag existiert
Procedure.s AWPB_LNG_Text(key.s, deftext.s)
  ProcedureReturn ____LNG_Text(key, deftext)
EndProcedure
;** awpb_lng_replacetext
;* Ersetzt einen Katalogeintrag.
;** .key.s: Schlssel des Spracheintrags
;** .text.s: der neue Spracheintrag
Procedure AWPB_LNG_ReplaceText(key.s, text.s)
  ____LNG_ReplaceText(key, text)
EndProcedure
;** awpb_lng_clearcatalog
;* Lscht alle Katalogeintrge.
Procedure AWPB_LNG_ClearCatalog()
  ____LNG_ClearCatalog()
EndProcedure
;}
 

